"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ReadGroupSet(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "id",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_4 import ga4gh as ga4gh_3_1_1

        return {
            "readGroups": ga4gh_3_1_1.ReadGroup,
            "stats": ga4gh_3_1_1.ReadStats,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_4 import ga4gh as ga4gh_3_1_1

        return {
            "org.ga4gh.models.ReadGroup": ga4gh_3_1_1.ReadGroup,
            "org.ga4gh.models.ReadStats": ga4gh_3_1_1.ReadStats,
            "org.ga4gh.models.ReadGroupSet": ga4gh_3_1_1.ReadGroupSet,
        }

    __slots__ = [
        "id",
        "datasetId",
        "name",
        "readGroups",
        "stats",
    ]

    def __init__(
        self,
        id,
        datasetId=None,
        name=None,
        readGroups=list,
        stats=None,
        validate=None,
        **kwargs
    ):
        """Initialise the ga4gh_3_1_1.ReadGroupSet model.

        :param id:
            The read group set ID.
        :type id: str
        :param datasetId:
            The ID of the dataset this read group set belongs to.
        :type datasetId: None | str
        :param name:
            The read group set name.
        :type name: None | str
        :param readGroups:
            The read groups in this set.
        :type readGroups: list[ReadGroup]
        :param stats:
            Statistical data on reads in this read group set.
        :type stats: None | ReadStats
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.1.1"
